//+------------------------------------------------------------------+
//|                                                Expert_V3  
//+------------------------------------------------------------------+
#define NAME_EXPERT "Expert_V4"
#define VER " V3"                                     
#define RELIZE "GS_2011_08_16"
string ex_Name = NAME_EXPERT;
//-------------
extern bool
   Comment_ON = true,
   PROTECT_ENTRY = true;   
//-------------
extern string 
   Rem_MM_0    = "*** ***";
extern double
   Risk = 10,
   Us_Lot = 0.01,
   Us_Max_Lot = 0.01,
   Fix_Profit = 0;
//-------------
extern string 
   Rem_Ord_0    = "*** ***";
extern int
   Us_Max_Num_Orders = 1,
   Us_Loss   = 0,
   Us_Profit = 0,
   Magic = 0;
//-------------
extern string 
   Rem_Trl_0    = "***  SL***"; //     
extern int
   Us_Tral_SL = 80;
extern bool
   TRAL_FROM_OUTLOSS = true;
extern int
   Min_Step_for_Tral = 3; 
extern int 
   Hold_Before_Tral = 1;  
//-------------
extern string 
   Rem_OutLos_0    = "*** ***";
extern int
   Us_Level_OutLoss = 30;
//-------------
extern string 
   Rem_PP_0    = "*** ***";
extern bool
   SET_LOCK = true;
extern bool
   TRAL_LOCK = true;
extern int
   Us_Num_Bars_for_Lock = 50,
   TF_Cnt_Bar_for_Lock = 1,
   Us_Dist_For_Top = 60,
   Us_Dist_For_Boot = 30;
//-------------
extern string 
   Rem_Par_0    = "*** ***";
extern bool
   Alert_ON = true;
extern bool
   Sound_ON = false;
extern int
   Bell_If_Open = 3;
extern bool
   Alert_ERR = true;
extern bool
   Advert_ON = false;
extern bool
   Draw_ARROW = true;
extern color 
   ColorArrowBuy = Blue,
   ColorArrowSell = Red;
//-------------
extern string 
   Rem_Ind_0    = "*** ***";
//-------------
extern string 
   Rem_Stoch_0    = "******";
extern int 
   Us_Stoch_Level = 20;
//-------------
#property copyright " valenok2003@mail.ru"
#property link      "http://bluedream.ucoz.ru"

#define AUTOR " valenok2003@mail.ru"
#define URL "http://bluedream.ucoz.ru"

#define NO_SIGNAL "NO"
#define SIGNAL_OP_BUY  "OP_BUY"
#define SIGNAL_CL_BUY  "CL_BUY"
#define SIGNAL_OP_SELL "OP_SELL"
#define SIGNAL_CL_SELL "CL_SELL"
#define SIGNAL_CL_ALL  "CL_ALL"

string 
   Name_Sound_Close  = "ok.wav",
   Name_Sound_Modify = "tick.wav",
   Name_Sound_Set    = "tick.wav",
   Name_Sound_Open   = "expert.wav",
   Name_Sound_Profit = "payment.wav",
   Name_Sound_Loss   = "ERROR.WAV",
   Signal_Open,
   Signal_Close,
   Txt_Comment = "",
   Comment_Order = "",
   Txt_Advert = "http://bluedream.ucoz.ru",
   ex_Name_for_System,
   ex_Name_for_Comment_Order;
int
   Ticket,
   Max_Num_Orders,
   Level_OutLoss,
   Dist_For_Top,
   Dist_For_Boot,
   Num_Bars_for_Lock_BUYSTOP,
   Num_Bars_for_Lock_SELLSTOP;
double
   Loss,
   Profit,
   Lot,
   Slip,
   Tral_SL,
   Stoch_Level,
   Start_Equity;   
bool        
   SOUND_SIGNAL      = false,
   ALLOW_SET_SL_TP   = false,
   ALLOW_SET_ORDER   = true,
   ALLOW_OPEN_BUY    = false,
   ALLOW_OPEN_SELL   = false,
   ALLOW_CLOSE_BUY   = false,
   ALLOW_CLOSE_SELL  = false,
   ALLOW_CLOSE_ALL   = false,
   CLOSE_ALL_FIX_PROFIT = false,
   ALLOW_SET_BUYSTOP    = true,
   ALLOW_SET_SELLSTOP   = true,
   ALLOW_TRAL_BUYSTOP   = true,
   ALLOW_TRAL_SELLSTOP  = true,
   DEL_ALL_BUYSTOP   = false,
   DEL_ALL_SELLSTOP  = false;
   
//+------------------------------------------------------------------+
//|            
//+------------------------------------------------------------------+
//| money_menegment() MM 
//| fix_profit()           
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                08.07.2011
//+------------------------------------------------------------------+
//| money_menegment() MM 
//| :
//| -    
//| -    
//|       
//+------------------------------------------------------------------+
double money_menegment(double _Risk, double _Lot)
{  string _Function = "money_menegment():";
   double _Min_Lot = MarketInfo(Symbol(),MODE_MINLOT);
//-------
   if(_Risk!=0)
   {  _Lot = AccountFreeMargin()*_Risk/100/MarketInfo(Symbol(),MODE_MARGINREQUIRED);
      if(_Lot > MarketInfo(Symbol(),MODE_MAXLOT)) _Lot = MarketInfo(Symbol(),MODE_MAXLOT);
      else if(_Lot > Us_Max_Lot && Us_Max_Lot != 0) _Lot = Us_Max_Lot;
   }
   if(_Lot < _Min_Lot) _Lot = _Min_Lot;
//-------
   if(_Min_Lot < 0.1) _Lot = NormalizeDouble(_Lot,2); 
   else _Lot = NormalizeDouble(_Lot,1);
//-------
   if(Comment_ON) {  
      Txt_Comment = Txt_Comment + "\n"+"== money menegment ==";
      if(Risk == 0)Txt_Comment = Txt_Comment + "\n"+"User Lot: "+DoubleToStr(Us_Lot,2);
      if(Risk != 0)  {
         Txt_Comment = Txt_Comment + "\n"+"Risk: "+DoubleToStr(Risk,2);
         Txt_Comment = Txt_Comment + "\n"+"Calc Lot: "+DoubleToStr(_Lot,2);
      }
      if(Us_Max_Lot != 0)Txt_Comment = Txt_Comment + "\n"+"User Max Lot: "+DoubleToStr(Us_Max_Lot,2);
   }
//-------
   return(_Lot);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                08.07.2011
//+------------------------------------------------------------------+
//| fix_profit()           
//| :
//| -    
//+------------------------------------------------------------------+
bool fix_profit(double _Lvl_Profit)
{  string _Function = "fix_profit():";
   bool _Ret = false;
   if(_Lvl_Profit == 0) return(_Ret);
//-------
   if(AccountEquity() >= Start_Equity+(Start_Equity/100)*_Lvl_Profit)   {  
      Start_Equity = AccountEquity();
      _Ret = true;
      output_alert(" !");
      Max_Num_Orders = Us_Max_Num_Orders;
   }
//-------
   if(Comment_ON) Txt_Comment = Txt_Comment + "\n"+"fix_profit: " + DoubleToStr(_Lvl_Profit,2)+"% = "
      +DoubleToStr(Start_Equity+(Start_Equity/100)*_Lvl_Profit ,2);
//-------
   return(_Ret);
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//|              
//+------------------------------------------------------------------+
//| check_dist()     
//| check_min_dist()   
//| cnt_num_orders()      
//| slipp()  Slippage:
//| txt_order_type()      
//| open_order_buy()    OP_BUY
//| open_order_sell()    OP_SELL
//| check_open_order()       
//| close_all_buy()     OP_BUY   
//| close_all_sell()     OP_SELL  
//| close_all_this_symbol()       
//| set_order_buystop()    OP_BUYSTOP
//| set_order_sellstop()    OP_SELLSTOP
//| close_for_ticket()       
//| txt_TF()                   
//| set_SL_and_TP()  SL  TP   
//| comment_num_orders()      
//+------------------------------------------------------------------+
//|                            
//+------------------------------------------------------------------+
//| output_alert()  
//| output_alert_ERR()   
//| output_sound()   
//| output_comment()  
//| output_signal()       
//| output_advert()   
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| check_dist()     
//|       
//+------------------------------------------------------------------+
void check_dist()
{  string _Function = "check_dist():";
   Loss = check_min_dist(Us_Loss,"StopLoss");
   Profit = check_min_dist(Us_Profit,"TakeProfit");   
//--------  ---------------------------------------------
   if(Comment_ON)
   {  Txt_Comment = Txt_Comment + "==  ==";
      Txt_Comment = Txt_Comment + "\n"+"Magic: "+Magic;   
      if(Loss != 0)Txt_Comment = Txt_Comment + "\n"+"StopLoss: "+DoubleToStr(Loss,0)+" point";
      if(Profit != 0)Txt_Comment = Txt_Comment + "\n"+"TakeProfit: "+DoubleToStr(Profit,0)+" point";
      Txt_Comment = Txt_Comment + "\n"+"Max_Num_Orders: "+Max_Num_Orders;
      if(Draw_ARROW)Txt_Comment = Txt_Comment + "\n"+"Draw_ARROW: ON";
      Txt_Comment = Txt_Comment + "\n"+"Slip: "+DoubleToStr(Slip,0);
   }
//------------------------------------------------------------------
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| check_min_dist()   
//| :
//| -   - SL  TP
//| -  , ,   
//+------------------------------------------------------------------+
int check_min_dist(double _Param, string _Txt)
{  string _Function = "check_min_dist():";
   double _Min_Dist = MarketInfo(Symbol(),MODE_STOPLEVEL);
   if(_Min_Dist == 0) _Min_Dist = Slip;
   if(_Param < _Min_Dist && _Param != 0) 
   {  _Param = _Min_Dist; 
   }
   return(_Param);
}  
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                08.07.2011
//+------------------------------------------------------------------+
//| cnt_num_orders()      
//| :        
//| -  
//| - 
//|     
//+------------------------------------------------------------------+
bool cnt_num_orders(int _Type_Order, int _Magic)
{  string _Function = "cnt_num_orders():";
   int _Cnt = 0;
   bool _RET = true;
   for(int _i=OrdersTotal()-1; _i>=0; _i--) 
   {  OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderType()==_Type_Order && OrderMagicNumber()==_Magic)
      _Cnt++; 
   }
   if(_Cnt >= Max_Num_Orders)
   {  _RET = false;
      output_alert_ERR("  " + txt_order_type(_Type_Order) + "  ");
   }
   return(_RET);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| slipp()  Slippage:
//|   .
//+------------------------------------------------------------------+
int slipp()
{  string _Function = "slipp():";
   static int _Slip;
//-------
   int _Tmp_Slip = MathRound((MarketInfo(Symbol(),MODE_ASK)-MarketInfo(Symbol(),MODE_BID))/Point);
   if(_Tmp_Slip > 0) _Slip = _Tmp_Slip;
//-------
   return(_Slip);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| txt_order_type()      
//+------------------------------------------------------------------+
string txt_order_type(int _Type_Order)
{  string _Function = "txt_order_type():",
      _Txt;
//--------
   switch(_Type_Order)
   {  case OP_BUY: _Txt = "OP_BUY";
      break;
      case OP_SELL: _Txt = "OP_SELL";
      break;
      case OP_BUYLIMIT: _Txt = "OP_BUYLIMIT";
      break;
      case OP_SELLLIMIT: _Txt = "OP_SELLLIMIT";
      break;
      case OP_BUYSTOP: _Txt = "OP_BUYSTOP";
      break;
      case OP_SELLSTOP: _Txt = "OP_SELLSTOP";
      break;
      default: 
         error(_Function, 4203);
      break;
   }  
   return(_Txt);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| open_order_buy()    OP_BUY
//| :
//| -                                 
//|      -1
//+------------------------------------------------------------------+
int open_order_buy(string _Comment)
{  string _Function = "open_order_buy():";
   int _Ticket=-1, _ERROR=0;
   int _Type_Order = OP_BUY;
//+-------
   output_alert_ERR(_Function+" OP_BUY");
   double _Price = NormalizeDouble(Ask,Digits);
   double _SL = 0; if(Loss != 0)  _SL = NormalizeDouble(Bid - Loss*Point,Digits);
   double _TP = 0; if(Profit != 0)_TP = NormalizeDouble(Bid + Profit*Point,Digits);
   _Ticket = OrderSend(Symbol(),OP_BUY,Lot,_Price,Slip,0,0,_Comment,Magic,0,ColorArrowBuy);
   _Ticket = check_open_order(_Type_Order,_Ticket, GetLastError());
//----
   return(_Ticket);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| open_order_sell()    OP_SELL
//| :
//| -                                 
//|      -1
//+------------------------------------------------------------------+
int open_order_sell(string _Comment)
{  string _Function = "open_order_sell():";
   int _Ticket=-1, _ERROR=0;
   int _Type_Order = OP_SELL;
//+-------
   output_alert_ERR(_Function+" OP_SELL");
   double _Price = NormalizeDouble(Bid,Digits);
   double _SL = 0; if(Loss != 0)  _SL = NormalizeDouble(Ask + Loss*Point,Digits);
   double _TP = 0; if(Profit != 0)_TP = NormalizeDouble(Ask - Profit*Point,Digits);
   _Ticket = OrderSend(Symbol(),_Type_Order,Lot,_Price,Slip,0,0,_Comment,Magic,0,ColorArrowSell);
   _Ticket = check_open_order(_Type_Order,_Ticket, GetLastError());
//----
   return(_Ticket);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| check_open_order()       
//| :
//| -  
//| -   
//| -  ,   OrderSend()                             
//|      -1
//+------------------------------------------------------------------+
int check_open_order(int _Type_Order, int _Ticket, int _ERROR)
{  string _Function = "check_open_order():";
//--------
   if(_Ticket > 0)
   {  OrderSelect(_Ticket,SELECT_BY_TICKET);             
      if((OrderType() ==  OP_SELL || OrderType() ==  OP_BUY) && _ERROR == 0)
      {  output_alert_ERR(_Function+txt_order_type(_Type_Order)+" !");
         output_sound(Name_Sound_Open);
         SOUND_SIGNAL = true;
      }
      else _Ticket = -1;
   }
   error(_Function + txt_order_type(_Type_Order), _ERROR);
//--------
   return(_Ticket);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| close_all_buy()     OP_BUY   
//|   = 0    OP_BUY  
//|  true     false     
//+------------------------------------------------------------------+
bool close_all_buy(int _Magic)
{  string _Function = "close_all_buy():";
   bool _RET = true;
//+-------
   for(int _i=OrdersTotal()-1; _i>=0; _i--) 
   {  OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if(OrderCloseTime() <=0)
      {  if(_Magic == 0)
         {  if(OrderSymbol()== Symbol() && OrderType() == OP_BUY) 
            {  if(!close_for_ticket(OrderTicket()))
               {  _RET = false;
               }
            }
         }
         else
         {  if(OrderSymbol()== Symbol() && OrderType() == OP_BUY && OrderMagicNumber() == _Magic) 
            {  if(!close_for_ticket(OrderTicket()))
               {  _RET = false;
               }
            }
         }
      }
   }
   if(_RET)output_alert_ERR(_Function+"  OP_BUY   "+Symbol()+" c  = "+_Magic);
   else output_alert_ERR(_Function+" ");
//----
   return(_RET);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| close_all_sell()     OP_SELL  
//|   = 0,    OP_SELL  
//|  true     false     
//+------------------------------------------------------------------+
bool close_all_sell(int _Magic)
{  string _Function = "close_all_sell():";
   bool _RET = true;
//+-------
   for(int _i=OrdersTotal()-1; _i>=0; _i--) 
   {  OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if(OrderCloseTime() <=0)
      {  if(_Magic == 0)
         {  if(OrderSymbol()== Symbol() && OrderType() == OP_SELL) 
            {  if(!close_for_ticket(OrderTicket()))
               {  _RET = false;
               }
            }
         }
         else
         {  if(OrderSymbol()== Symbol() && OrderType() == OP_SELL && OrderMagicNumber() == _Magic) 
            {  if(!close_for_ticket(OrderTicket()))
               {  _RET = false;
               }
            }
         }
      }
   }
   if(_RET)output_alert_ERR(_Function+"  OP_SELL   "+Symbol()+" c  = "+_Magic);
   else output_alert_ERR(_Function+" ");
//----
   return(_RET);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                18.07.2011
//+------------------------------------------------------------------+
//| close_all_this_symbol()       
//|    true,    false
//+------------------------------------------------------------------+
bool close_all_this_symbol(int _Magic)
{  string _Function = "close_all_this_symbol():";
   bool _REZ = true;
//----
   for(int _i=OrdersTotal()-1; _i>=0; _i--) 
   {  OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderCloseTime() <=0 && OrderMagicNumber()==_Magic)
      {  if(OrderType()==OP_BUY) color _ColorArrow = ColorArrowBuy;
         if(OrderType()==OP_SELL) _ColorArrow = ColorArrowSell;
         if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), Slip, _ColorArrow))
            _REZ = false;
      }
   }
   if(_REZ)output_alert_ERR(_Function+"     "+Symbol()+" c  = "+_Magic);
   else output_alert_ERR(_Function+" ");
//----
   return(_REZ);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                26.05.2011
//+------------------------------------------------------------------+
//| set_order_buystop()    OP_BUYSTOP
//| :                     
//| - 
//| - 
//|  ,     -1
//+------------------------------------------------------------------+
int set_order_buystop(double _Price, double _Lot, string _Comment)
{  string _Function = "set_order_buystop():";
   int _Ticket=-1, _ERROR=0;
   double _SL = 0; if(Loss != 0)   _SL = NormalizeDouble(_Price - Loss*Point, Digits);
   double _TP = 0; if(Profit != 0) _TP = NormalizeDouble(_Price + Profit*Point, Digits);
   _Ticket = OrderSend(Symbol(),OP_BUYSTOP,_Lot,_Price,0,_SL,_TP,_Comment,Magic,0,CLR_NONE);
   _ERROR = GetLastError();
   if(_Ticket > 0) //  
   {  OrderSelect(_Ticket,SELECT_BY_TICKET);             
      if(OrderType() ==  OP_BUYSTOP && _ERROR == 0)output_sound(Name_Sound_Set);
      else _Ticket = -1;
   }
   if(_Ticket == -1) error(_Function + "_Lot= " + _Lot, _ERROR);
   return(_Ticket);
}
//+-------------------------------------------------------------------
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                26.05.2011
//+------------------------------------------------------------------+
//| set_order_sellstop()    OP_SELLSTOP
//| :                     
//| - 
//| - 
//|  ,     -1
//+------------------------------------------------------------------+
int set_order_sellstop(double _Price, double _Lot, string _Comment)
{  string _Function = "set_order_sellstop():";
   int _Ticket = -1, _ERROR=0;
   double _SL = 0; if(Loss != 0)   _SL = NormalizeDouble(_Price + Loss*Point, Digits);
   double _TP = 0; if(Profit != 0) _TP = NormalizeDouble(_Price - Profit*Point, Digits);
   _Ticket = OrderSend(Symbol(),OP_SELLSTOP,_Lot,_Price,0,_SL,_TP,_Comment,Magic,0,CLR_NONE);
   _ERROR = GetLastError();
   if(_Ticket > 0) //  
   {  OrderSelect(_Ticket,SELECT_BY_TICKET);             
      if(OrderType() ==  OP_SELLSTOP && _ERROR == 0)output_sound(Name_Sound_Set);
      else _Ticket = -1;
   }
   if(_Ticket == -1) error(_Function + "_Lot= " + _Lot, _ERROR);
   return(_Ticket);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                08.07.2011
//+------------------------------------------------------------------+
//| close_for_ticket()       
//| :
//| -  ;
//|    true,    false
//+------------------------------------------------------------------+
bool close_for_ticket(int _Ticket)
{  string _Function = "close_for_ticket():";
   int  
      _ERROR=0;
   bool 
      _RET = true;
//+-------
   if(_Ticket == 0)return(_RET);
//+-------
   OrderSelect(_Ticket, SELECT_BY_TICKET); 
   if(OrderCloseTime()>0) return(_RET);
   int _Type_Order = OrderType();
   output_alert_ERR(_Function+" " + txt_order_type(_Type_Order));
   switch(_Type_Order)
   {  case OP_BUY:
         _RET = OrderClose(_Ticket, OrderLots(), OrderClosePrice(), Slip, ColorArrowBuy);
         _ERROR = GetLastError();
      break;
      case OP_SELL:
         _RET = OrderClose(_Ticket, OrderLots(), OrderClosePrice(), Slip, ColorArrowSell);
         _ERROR = GetLastError();
      break;
      case OP_SELLLIMIT:
         _RET = OrderDelete(_Ticket, CLR_NONE);
         _ERROR = GetLastError();
      break;
      case OP_SELLSTOP:
         _RET = OrderDelete(_Ticket, CLR_NONE);
         _ERROR = GetLastError();
      break;
      case OP_BUYLIMIT:
         _RET = OrderDelete(_Ticket, CLR_NONE);
         _ERROR = GetLastError();
      break;
      case OP_BUYSTOP:
         _RET = OrderDelete(_Ticket, CLR_NONE);
         _ERROR = GetLastError();
      break;
      default:
         error(_Function, 4203);
      break;
   }
   if(!_RET){ error(_Function + txt_order_type(_Type_Order), _ERROR);}
   else 
   {  output_alert_ERR(_Function+txt_order_type(_Type_Order)+" !");
      OrderSelect(_Ticket, SELECT_BY_TICKET); 
      if(OrderProfit()>0) output_sound(Name_Sound_Profit);
      else output_sound(Name_Sound_Loss);
      _Ticket = 0;
   }
//+-------
   return(_RET);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                14.06.2011
//+------------------------------------------------------------------+
//| txt_TF()                   
//+------------------------------------------------------------------+
string txt_TF( int _TF)
{  string _Function = "txt_TF():";
   string _Txt_TF;
   switch(_TF)
   {
     case PERIOD_M1:  _Txt_TF = "M1";  break;
     case PERIOD_M5:  _Txt_TF = "M5";  break;
     case PERIOD_M15: _Txt_TF = "M15"; break;
     case PERIOD_M30: _Txt_TF = "M30"; break;
     case PERIOD_H1:  _Txt_TF = "H1";  break;
     case PERIOD_H4:  _Txt_TF = "H4";  break;
     case PERIOD_D1:  _Txt_TF = "D1";  break;
     case PERIOD_W1:  _Txt_TF = "W1";  break;
     case PERIOD_MN1: _Txt_TF = "MN1"; break;
     default: Alert("   " + _TF); break;
   }
   return(_Txt_TF);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| set_SL_and_TP()  SL  TP   
//|     . 
//| :
//| -  
//| -  SL
//| -  TP
//|    0,     
//+------------------------------------------------------------------+
bool set_SL_and_TP(int _Ticket,double _Loss,double _Profit)
{  string _Function = "set_SL_and_TP():";
   int   _ERROR=0;
   bool  _RET = false;
   double _TP,_SL;
//+-------
   if(_Loss == 0 && _Profit == 0)
   {  return(true);
   }
   if(_Ticket == 0)
   {  return(true);
   }
//+-------
   if(!OrderSelect(_Ticket, SELECT_BY_TICKET)) return(true);
   if(OrderCloseTime()>0) return(true);
   else
   {  switch(OrderType())
      {  case OP_BUY:
            _SL = 0; if(_Loss > 0)  _SL = NormalizeDouble(Bid - _Loss *Point,Digits);
            _TP = 0; if(Profit > 0) _TP = NormalizeDouble(Bid + Profit*Point,Digits);
            _RET = OrderModify(_Ticket,OrderOpenPrice(),_SL,_TP,0,CLR_NONE);
            _ERROR = GetLastError();
         break;
         case OP_SELL:
            _SL = 0; if(_Loss > 0)  _SL = NormalizeDouble(Ask + _Loss  *Point,Digits);
            _TP = 0; if(Profit > 0) _TP = NormalizeDouble(Ask - _Profit*Point,Digits);
            _RET = OrderModify(_Ticket,OrderOpenPrice(),_SL,_TP,0,CLR_NONE);
            _ERROR = GetLastError();
         break;
         default:
            _ERROR = 4203;
         break;
      }
   }
   if(!_RET) error(_Function, _ERROR);
   else output_alert_ERR(" !");
   return(_RET);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                08.07.2011
//+------------------------------------------------------------------+
//| comment_num_orders()      
//| :        
//| - 
//+------------------------------------------------------------------+
void comment_num_orders(int _Magic)
{  if(!Comment_ON) return;
   string _Function = "comment_num_orders():";
   int _Cnt_BUY = 0;
   int _Cnt_SELL = 0;
   int _Cnt_BUYSTOP = 0;
   int _Cnt_SELLSTOP = 0;
   for(int _i=OrdersTotal()-1; _i>=0; _i--) 
   {  OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==_Magic)
         _Cnt_BUY++; 
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==_Magic)
         _Cnt_SELL++; 
      if(OrderSymbol()==Symbol() && OrderType()==OP_BUYSTOP && OrderMagicNumber()==_Magic)
         _Cnt_BUYSTOP++; 
      if(OrderSymbol()==Symbol() && OrderType()==OP_SELLSTOP && OrderMagicNumber()==_Magic)
         _Cnt_SELLSTOP++; 
   }
//   Txt_Comment = Txt_Comment + "\n";
   Txt_Comment = Txt_Comment + "\n"+"==   ==";
//   Txt_Comment = Txt_Comment + "\n"+" : "+MarketInfo(); OrderClose
   if(_Cnt_BUY != 0)     Txt_Comment = Txt_Comment + "\n"+"OP_BUY: "     +_Cnt_BUY;
   if(_Cnt_SELL != 0)    Txt_Comment = Txt_Comment + "\n"+"OP_SELL: "    +_Cnt_SELL;
   if(_Cnt_BUYSTOP != 0) Txt_Comment = Txt_Comment + "\n"+"OP_BUYSTOP: " +_Cnt_BUYSTOP;
   if(_Cnt_SELLSTOP != 0)Txt_Comment = Txt_Comment + "\n"+"OP_SELLSTOP: "+_Cnt_SELLSTOP;
   return;
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| output_alert()  
//| :
//| -  
//+------------------------------------------------------------------+
void output_alert(string _Txt_Alert)
{  string _Function = "output_alert():";
   if(Alert_ON == true) Alert(ex_Name_for_System + _Txt_Alert);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| output_alert_ERR()   
//| :
//| -  
//+------------------------------------------------------------------+
void output_alert_ERR(string _Txt_Alert_ERR)
{  string _Function = "output_alert_ERR():";
   if(Alert_ERR == true) Alert(ex_Name_for_System + _Txt_Alert_ERR);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| output_sound()   
//| :
//| -   
//+------------------------------------------------------------------+
void output_sound(string _Name_Sound)
{  string _Function = "output_sound():";
   if(!Alert_ON)
      if(Sound_ON == true) 
         PlaySound(_Name_Sound);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                28.07.2011
//+------------------------------------------------------------------+
//| output_signal()       
//| :
//| - 
//+------------------------------------------------------------------+
bool output_signal(bool _SOUND_SIGNAL)
{  string _Function = "output_signal():";
   static int _Cnt = 0;
   if(_SOUND_SIGNAL && Bell_If_Open != 0){
      PlaySound("alert.wav");
      _Cnt++;
      if(_Cnt >= Bell_If_Open)  {
         _Cnt = 0;
         _SOUND_SIGNAL = false;
      }
   }
   return(_SOUND_SIGNAL);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| output_advert()   
//+------------------------------------------------------------------+
void output_advert()
{  string _Function = "output_advert()";
   if(!Advert_ON)return;
   ObjectCreate ("Advert", OBJ_LABEL, 0, 0, 0);
   ObjectSet    ("Advert", OBJPROP_CORNER, 2);
   ObjectSet    ("Advert", OBJPROP_XDISTANCE, 5);
   ObjectSet    ("Advert", OBJPROP_YDISTANCE, 5);
   ObjectSetText("Advert", Txt_Advert, 10, "Arial", LimeGreen);
   return;
}
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| output_comment()  
//+------------------------------------------------------------------+
void output_comment(string _Txt_Comment)
{  string _Function = "output_comment()";
   {  if(Comment_ON){  
//         Txt_Comment = Txt_Comment + "\n";
         Txt_Comment = Txt_Comment + "\n"+"==  ==";
         string _Txt_Alert = "OFF";
         if(Alert_ON)_Txt_Alert = "ON";
         Txt_Comment = Txt_Comment + "\n"+"Alert "+ _Txt_Alert;
         string _Txt_Alert_ERR = "OFF";
         if(Alert_ERR)_Txt_Alert_ERR = "ON";
         Txt_Comment = Txt_Comment + "\n"+"Alert_ERR "+ _Txt_Alert_ERR;
         string _Txt_Sound = "OFF";
         if(Sound_ON)_Txt_Sound = "ON";
         Txt_Comment = Txt_Comment + "\n"+"Sound "+ _Txt_Sound;
         string _Txt_Advert = "OFF";
         if(Advert_ON)_Txt_Advert = "ON";
         Txt_Comment = Txt_Comment + "\n"+"Advert "+ _Txt_Advert;
         string _Txt_Signals = Bell_If_Open;
         if(Bell_If_Open == 0)_Txt_Signals = "OFF";
         Txt_Comment = Txt_Comment + "\n"+"Bell_If_Open: "+ _Txt_Signals;
      }
   }
   Comment(Txt_Comment); 
   return;  
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//|                     
//+------------------------------------------------------------------+
//| tral_SL()  StopLoss          
//| tral_SL_for_ticket()  StopLoss    
//| set_outloss()  SL   
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| tral_SL()  StopLoss          
//| :
//| -  SL       Magic != 0;
//| -  SL    Magic == 0;
//| -       _Hold_Before_Tral 
//| :
//| - Magic
//| - tral_SL_for_ticket()
//+------------------------------------------------------------------+
void tral_SL(int _Magic)
{  string _Function = "tral_SL():";
   static bool _SET_TIMER_TRAL = false;
   static int _Timer_Tral = 0; 
//--------  ---------------------------------------------
   if(Comment_ON) {  
//      Txt_Comment = Txt_Comment + "\n";
      Txt_Comment = Txt_Comment + "\n"+"==  ==";
   }
//------------------------------------------------------------------
   if(Tral_SL == 0)  {
      if(Comment_ON) Txt_Comment = Txt_Comment+ "\n"+_Function + "OFF";
      return;
   }
   Tral_SL = check_min_dist(Tral_SL,"TralingStop");   
//--------  ---------------------------------------------
   if(Comment_ON) {  
      Txt_Comment = Txt_Comment + "\n"+"Tral_SL: "+DoubleToStr(Tral_SL,0)+" point";
      //Txt_Comment = Txt_Comment + "\n"+"Tral_SL Step: "+Min_Step_for_Tral+" point";
      //Txt_Comment = Txt_Comment + "\n"+"Hold Tral_SL: "+Hold_Before_Tral+" ";
      if(TRAL_FROM_OUTLOSS) Txt_Comment = Txt_Comment + "\n"+"TRAL_FROM_OUTLOSS";
      else Txt_Comment = Txt_Comment + "\n"+"TRAL_FROM_STOPLOSS";
   }
//------------------------------------------------------------------
   if(Hold_Before_Tral !=0)
   {  if(!_SET_TIMER_TRAL)                                     
      {  _Timer_Tral = TimeCurrent();                          
         _SET_TIMER_TRAL = true;
      }                                                          
      if(_SET_TIMER_TRAL)                                     
      {  if(TimeCurrent() <  _Timer_Tral + Hold_Before_Tral) return;
         _SET_TIMER_TRAL = false;
      }
   }
   int _i;
   double _SL;
   for(_i=OrdersTotal()-1; _i>=0; _i--) 
   {  OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol() == Symbol())
      {  if(_Magic == 0) tral_SL_for_ticket(OrderTicket());
         else if(OrderMagicNumber() == _Magic) tral_SL_for_ticket(OrderTicket());
      }
   }
   return;
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| tral_SL_for_ticket()  StopLoss    
//|     
//| :
//| -   
//| -  SL    -  TRAL_FROM_OUTLOSS = true
//| -  SL     -  TRAL_FROM_OUTLOSS = false
//|  SL=0,       
//| :     
//| -  
//+------------------------------------------------------------------+
//extern 
void tral_SL_for_ticket(int _Ticket)
{  string _Function = "tral_SL_for_ticket():";
   double _SL;
   //if(Tral_SL == 0) return;
   if(OrderSelect(_Ticket, SELECT_BY_TICKET))
   {  if(OrderType() == OP_BUY)
      {  if(TRAL_FROM_OUTLOSS || OrderStopLoss() == 0) 
         {  if(Bid - OrderOpenPrice() > Tral_SL*Point) 
            {  if(OrderStopLoss() < Bid - Tral_SL*Point)
               {  _SL = NormalizeDouble(Bid - Tral_SL*Point,Digits);
                  if(MathAbs(_SL - OrderStopLoss()) < Min_Step_for_Tral*Point) return;
                  OrderModify(OrderTicket(),OrderOpenPrice(),_SL,OrderTakeProfit(),0,CLR_NONE);
               }
            }
         }
         else
         {  if(Bid - OrderStopLoss() > Tral_SL*Point && OrderStopLoss()) 
            {  _SL = NormalizeDouble(Bid - Tral_SL*Point,Digits);
               if(MathAbs(_SL - OrderStopLoss()) < Min_Step_for_Tral*Point) return;
               OrderModify(OrderTicket(),OrderOpenPrice(),_SL,OrderTakeProfit(),0,CLR_NONE);
            }
         }            
      }
      if(OrderType() == OP_SELL)
      {  if(TRAL_FROM_OUTLOSS  || OrderStopLoss() == 0) 
         {  if(OrderOpenPrice() - Ask > Tral_SL*Point)
            {  if(OrderStopLoss() > Ask + Tral_SL*Point || OrderStopLoss()==0)
               {  _SL = NormalizeDouble(Ask + Tral_SL*Point,Digits);
                  if(MathAbs(_SL - OrderStopLoss()) < Min_Step_for_Tral*Point) return;
                  OrderModify(OrderTicket(),OrderOpenPrice(),_SL,OrderTakeProfit(),0,CLR_NONE);
               }
            }
         }
         else
         {  if(OrderStopLoss() - Ask > Tral_SL*Point)
            {  _SL = NormalizeDouble(Ask + Tral_SL*Point,Digits);
               if(MathAbs(_SL - OrderStopLoss()) < Min_Step_for_Tral*Point) return;
               OrderModify(OrderTicket(),OrderOpenPrice(),_SL,OrderTakeProfit(),0,CLR_NONE);
            }
         }
      }
   }
   return;
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                27.07.2011
//+------------------------------------------------------------------+
//| set_outloss()  SL   
//|  Level_OutLoss = 0, 
//+------------------------------------------------------------------+
void set_outloss()
{  string _Function = "set_outloss():";
   double _SL;
//--------  ---------------------------------------------
   if(Comment_ON) {  
//      Txt_Comment = Txt_Comment + "\n";
      Txt_Comment = Txt_Comment + "\n"+"==  ==";
   }
//------------------------------------------------------------------
   if(Level_OutLoss == 0)  {
      if(Comment_ON) Txt_Comment = Txt_Comment+ "\n"+_Function + "OFF";      
      return;
   }
   if(Comment_ON) Txt_Comment = Txt_Comment + "\n"+"Level OutLoss: "+ Level_OutLoss + " point";
   for(int _i=OrdersTotal()-1; _i>=0; _i--) 
   {  OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol() == Symbol() && OrderCloseTime()<=0 && OrderMagicNumber() == Magic)
      {  if(OrderType() == OP_BUY)
         {  if(OrderStopLoss() < OrderOpenPrice())
            {  if(Bid - OrderOpenPrice() > Level_OutLoss*Point) 
               {  _SL = NormalizeDouble(OrderOpenPrice()+2*Point,Digits);
                  OrderModify(OrderTicket(),OrderOpenPrice(),_SL,OrderTakeProfit(),0,CLR_NONE);
               }
            }
         }  
         if(OrderType() == OP_SELL)
         {  if(OrderStopLoss() > OrderOpenPrice() || OrderStopLoss() == 0)
            {  if(OrderOpenPrice() - Ask > Level_OutLoss*Point)
               {  _SL = NormalizeDouble(OrderOpenPrice()-2*Point,Digits);
                  OrderModify(OrderTicket(),OrderOpenPrice(),_SL,OrderTakeProfit(),0,CLR_NONE);
               }
            }
         }
      }
   }
   return;
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//|                     
//+------------------------------------------------------------------+
//| set_lock()         
//| tral_lock()   -  
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                29.07.2011
//+------------------------------------------------------------------+
//| set_lock()        
//| :
//| -    
//| :
//| - Magic
//+------------------------------------------------------------------+
void set_lock()
{  string _Function = "set_lock():";
//--------   -----------------------------------
   if(Comment_ON) {
//      Txt_Comment = Txt_Comment + "\n";
      Txt_Comment = Txt_Comment + "\n"+"==  ==";
   }
//------------------------------------------------------------------
   if(!SET_LOCK) {
//--------  ---------------------------------------------
      if(Comment_ON) {
         Txt_Comment = Txt_Comment + "\n"+_Function+" OFF";
      }
//------------------------------------------------------------------
      return;
   }
//--------  ---------------------------------------------
   if(Comment_ON) {  
      Txt_Comment = Txt_Comment + "\n"+"Num_Bars_for_Lock_BUYSTOP: "   + Num_Bars_for_Lock_BUYSTOP;
      Txt_Comment = Txt_Comment + "\n"+"Num_Bars_for_Lock_SELLSTOP: "  + Num_Bars_for_Lock_SELLSTOP;
      Txt_Comment = Txt_Comment + "\n"+"TF_Cnt_Bar_for_Lock: " + TF_Cnt_Bar_for_Lock;
   }
//------------------------------------------------------------------
   int _i, 
       _Ticket_Order_For_Del;
   double _Lot_Order_For_Del = 0;
   double _Price;
   string _Txt_Lock = "Lock ";
   static int _Bars_PP_OP_BUYSTOP =0;
   static int _Bars_PP_OP_SELLSTOP =0;
   static bool _RESET_Bars_PP_OP_BUYSTOP = true;
   static bool _RESET_Bars_PP_OP_SELLSTOP = true;
   int _Normalize_Lot; 
   double _Min_Lot = MarketInfo(Symbol(),MODE_MINLOT);
   if(_Min_Lot < 0.1) _Normalize_Lot = 2; 
   else _Normalize_Lot = 1; 
//-----   ----------------------------------------------
   double _Lot = 0;
   double _Dif_Lot = 0;
   double _Lot_BUY = 0;
   double _Lot_SELL = 0;
   double _Lot_BUYSTOP = 0;
   double _Lot_SELLSTOP = 0;
   for(_i=OrdersTotal()-1; _i>=0; _i--){  
      // RefreshRates(); 
      OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol() == Symbol() && OrderCloseTime()<=0 && OrderMagicNumber() == Magic){  
         if(OrderType() == OP_BUY)      _Lot_BUY  += OrderLots();
         if(OrderType() == OP_SELL)     _Lot_SELL += OrderLots();
         if(OrderType() == OP_BUYSTOP)  _Lot_BUYSTOP  += OrderLots();
         if(OrderType() == OP_SELLSTOP) _Lot_SELLSTOP += OrderLots();
      }
   }
   _Lot_BUY  = NormalizeDouble(_Lot_BUY,_Normalize_Lot);   
   _Lot_SELL = NormalizeDouble(_Lot_SELL,_Normalize_Lot);   
   _Lot_BUYSTOP  = NormalizeDouble(_Lot_BUYSTOP,_Normalize_Lot);   
   _Lot_SELLSTOP = NormalizeDouble(_Lot_SELLSTOP,_Normalize_Lot);
//-------------------------------------------------------------------
//-----   ---------------------------------------------
//------------------------------------------------------------------
   if(_RESET_Bars_PP_OP_BUYSTOP)  _Bars_PP_OP_BUYSTOP  = Num_Bars_for_Lock_BUYSTOP;
   if(_RESET_Bars_PP_OP_SELLSTOP) _Bars_PP_OP_SELLSTOP = Num_Bars_for_Lock_SELLSTOP;
//---------   
   if(_Lot_BUY == _Lot_SELL) {
      //    
      for(_i=OrdersTotal()-1; _i>=0; _i--){ 
         // RefreshRates(); 
         OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol() == Symbol() && OrderCloseTime()<=0 && OrderMagicNumber() == Magic 
         && (OrderType() == OP_SELLSTOP || OrderType() == OP_BUYSTOP))  {
            output_alert_ERR(_Function+"   ");
            if(!close_for_ticket(OrderTicket())) return;
         }
      }
   }
   else  {
      if(_Lot_SELL > _Lot_BUY+_Lot_BUYSTOP) {
         _Price = NormalizeDouble((High[iHighest(Symbol(),TF_Cnt_Bar_for_Lock,MODE_HIGH,_Bars_PP_OP_BUYSTOP,0)]+ Dist_For_Top*Point),Digits);
         if(_Price - Ask < Dist_For_Top*Point) {
            _Bars_PP_OP_BUYSTOP *=2;
            _RESET_Bars_PP_OP_BUYSTOP = false;
            return;
         }
         _Dif_Lot = _Lot_SELL-_Lot_BUY-_Lot_BUYSTOP;
   //Alert(_Lot+" "+_Lot_SELL+" "+_Lot_BUY+" "+_Lot_BUYSTOP);         
         if(_Dif_Lot >= 0.01)  _Lot = 0.01;
         if(_Dif_Lot >= 0.1)   _Lot = 0.1;
         if(_Dif_Lot >= 1.0)   _Lot = 1.0;
         if(_Dif_Lot >= 10.0)  _Lot = 10.0;
         if(_Lot != 0)  {
            if(set_order_buystop(_Price, _Lot, _Txt_Lock+Comment_Order)!= -1) {
               _RESET_Bars_PP_OP_BUYSTOP = true;
            }
         }
      }
      else if(_Lot_BUY < _Lot_SELL+_Lot_SELLSTOP) {
         for(_i=OrdersTotal()-1; _i>=0; _i--){  
            // RefreshRates(); 
            OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol() == Symbol() && OrderCloseTime()<=0 
            && OrderMagicNumber() == Magic && (OrderType() == OP_SELLSTOP))  {
               if(OrderLots() > _Lot_Order_For_Del) {
                  _Lot_Order_For_Del = OrderLots();
                  _Ticket_Order_For_Del = OrderTicket();
               }
            }
         }
         if(OrderSelect(_Ticket_Order_For_Del,SELECT_BY_TICKET))   {
            if(OrderCloseTime()<= 0) {
               output_alert_ERR(_Function+" close_for_ticket()   OP_SELLSTOP");
               if(!close_for_ticket(_Ticket_Order_For_Del)) return;
               _Ticket_Order_For_Del = 0; 
            }
         }        
      }
//-----------------
      if(_Lot_BUY > _Lot_SELL+_Lot_SELLSTOP) {
         _Price = NormalizeDouble((Low [iLowest (Symbol(),TF_Cnt_Bar_for_Lock,MODE_LOW, _Bars_PP_OP_SELLSTOP,0)]- Dist_For_Boot*Point),Digits);
         if(Bid - _Price < Dist_For_Boot*Point) {
            _Bars_PP_OP_SELLSTOP *=2;
            _RESET_Bars_PP_OP_SELLSTOP = false;
            return;
         }
         _Dif_Lot = _Lot_BUY-_Lot_SELL-_Lot_SELLSTOP;
         if(_Dif_Lot >= 0.01) _Lot = 0.01;
         if(_Dif_Lot >= 0.1)  _Lot = 0.1;
         if(_Dif_Lot >= 1.0)  _Lot = 1.0;
         if(_Dif_Lot >= 10.0) _Lot = 10.0;
         if(_Lot != 0)  {
            if(set_order_sellstop(_Price, _Lot, _Txt_Lock+Comment_Order)!= -1){
               _RESET_Bars_PP_OP_SELLSTOP = true;
               _Lot = 0;
            }
         }
      }
      else if(_Lot_SELL < _Lot_BUY+_Lot_BUYSTOP) {
         for(_i=OrdersTotal()-1; _i>=0; _i--){  
            // RefreshRates(); 
            OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
            if(OrderSymbol() == Symbol() && OrderCloseTime()<=0 
            && OrderMagicNumber() == Magic && (OrderType() == OP_BUYSTOP))  {
               if(OrderLots() > _Lot_Order_For_Del) {
                  _Lot_Order_For_Del = OrderLots();
                  _Ticket_Order_For_Del = OrderTicket();
               }
            }
         }
         if(OrderSelect(_Ticket_Order_For_Del,SELECT_BY_TICKET))   {
            if(OrderCloseTime()<= 0) {
               output_alert_ERR(_Function+" close_for_ticket()   OP_BUYSTOP");
               if(!close_for_ticket(_Ticket_Order_For_Del)) return;
               _Ticket_Order_For_Del = 0; 
            }
         }        
      }
   }
//--------  ---------------------------------------------
   if(Comment_ON) {  
      if(_Lot_BUY!=0)      Txt_Comment = Txt_Comment + "\n"+"Lot_BUY: "     + DoubleToStr(_Lot_BUY,_Normalize_Lot);
      if(_Lot_SELL!=0)     Txt_Comment = Txt_Comment + "\n"+"Lot_SELL: "    + DoubleToStr(_Lot_SELL,_Normalize_Lot);
      if(_Lot_BUYSTOP!=0)  Txt_Comment = Txt_Comment + "\n"+"Lot_BUYSTOP: " + DoubleToStr(_Lot_BUYSTOP,_Normalize_Lot);
      if(_Lot_SELLSTOP!=0) Txt_Comment = Txt_Comment + "\n"+"Lot_SELLSTOP: "+ DoubleToStr(_Lot_SELLSTOP,_Normalize_Lot);
   }
//------------------------------------------------------------------
//-------------------------------------------------------------------
   return;
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                29.07.2011
//+------------------------------------------------------------------+
//| tral_lock()   -  
//| :
//| -    
//| :
//| - Magic
//+------------------------------------------------------------------+
void tral_lock()
{  string _Function = "tral_lock():";
   if(!SET_LOCK || !TRAL_LOCK){
      if(Comment_ON) Txt_Comment = Txt_Comment + "\n"+_Function+" OFF";
      return;
   }
   static int _Bars_TL_OP_BUYSTOP  = 0;
   static int _Bars_TL_OP_SELLSTOP = 0;
   static bool _RESET_Bars_TL_OP_BUYSTOP  = true;
   static bool _RESET_Bars_TL_OP_SELLSTOP = true;
   double _Price;
//--------- 
   if(_RESET_Bars_TL_OP_BUYSTOP)  _Bars_TL_OP_BUYSTOP  = Num_Bars_for_Lock_BUYSTOP;
   if(_RESET_Bars_TL_OP_SELLSTOP) _Bars_TL_OP_SELLSTOP = Num_Bars_for_Lock_SELLSTOP;
//---------
   for(int _i=OrdersTotal()-1; _i>=0; _i--){  
      // RefreshRates(); 
      OrderSelect(_i, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol() == Symbol() && OrderCloseTime()<=0 && OrderMagicNumber() == Magic){  
         if(OrderType() == OP_BUYSTOP && ALLOW_TRAL_BUYSTOP)    {
            _Price = NormalizeDouble((High[iHighest(Symbol(),TF_Cnt_Bar_for_Lock,MODE_HIGH,_Bars_TL_OP_BUYSTOP,0)]+ Dist_For_Top*Point),Digits);
            if(_Price - Ask < Dist_For_Top*Point) {
               _Bars_TL_OP_BUYSTOP *=2;
               _RESET_Bars_TL_OP_BUYSTOP = false;
            }
            if(OrderOpenPrice() > _Price){
               if(OrderModify(OrderTicket(),_Price,OrderStopLoss(),OrderTakeProfit(),0,CLR_NONE))  { 
                  _RESET_Bars_TL_OP_BUYSTOP = true;
               }
            }
         }
         if(OrderType() == OP_SELLSTOP && ALLOW_TRAL_SELLSTOP)   {
            _Price = NormalizeDouble((Low [iLowest (Symbol(),TF_Cnt_Bar_for_Lock,MODE_LOW, _Bars_TL_OP_SELLSTOP,0)]- Dist_For_Boot*Point),Digits);
            if(Bid - _Price < Dist_For_Boot*Point) {
               _Bars_TL_OP_SELLSTOP *=2;
               _RESET_Bars_TL_OP_SELLSTOP = false;
            }
            if(OrderOpenPrice() < _Price){
               if(OrderModify(OrderTicket(),_Price,OrderStopLoss(),OrderTakeProfit(),0,CLR_NONE))  {
                  _RESET_Bars_TL_OP_SELLSTOP = true;
               }
            }
         }
      }
   }
   return;
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//|            
//+------------------------------------------------------------------+
//| error()  
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                05.07.2011
//+------------------------------------------------------------------+
//| error()  
//| :                  
//| -  ; 
//| -   
//| -  ;  
//+------------------------------------------------------------------+
string error(string _Function, int _Num_Error)
{  string _Txt_Error = "";
   switch(_Num_Error)
   { //----  ,   :
      case 0:   _Txt_Error = " ";                                               break;
      case 1:   _Txt_Error = " ,   ";                      break;
      case 2:   _Txt_Error = " ";                                             break;
      case 3:   _Txt_Error = " ";                                   break;
      case 4:   _Txt_Error = "  ";                                    break;
      case 5:   _Txt_Error = "   ";                      break;
      case 6:   _Txt_Error = "    ";                            break;
      case 7:   _Txt_Error = " ";                                        break;
      case 8:   _Txt_Error = "  ";                                   break;
      case 9:   _Txt_Error = "   ";             break;
      case 64:  _Txt_Error = " ";                                        break;
      case 65:  _Txt_Error = "  ";                                 break;
      case 128: _Txt_Error = "    ";                    break;
      case 129: _Txt_Error = " ";                                        break;
      case 130: _Txt_Error = " ";                                       break;
      case 131: _Txt_Error = " ";                                       break;
      case 132: _Txt_Error = " ";                                             break;
      case 133: _Txt_Error = " ";                                       break;  
      case 134: _Txt_Error = "    ";               break;
      case 135: _Txt_Error = " ";                                          break;
      case 136: _Txt_Error = " ";                                                 break;
      case 137: _Txt_Error = " ";                                             break;
      case 138: _Txt_Error = " ";                                               break;
      case 139: _Txt_Error = "    ";                  break;
      case 140: _Txt_Error = "  ";                                 break;
      case 141: _Txt_Error = "  ";                                   break;
      case 145: _Txt_Error = " ,     ";      break;
      case 146: _Txt_Error = "  ";                               break;
      case 147: _Txt_Error = "     ";   break;
      case 148: _Txt_Error = "   .";                     break;
      //----    MQL4-:
      case 4000: _Txt_Error = " ";                                              break;
      case 4001: _Txt_Error = "  ";                          break;
      case 4002: _Txt_Error = "  -  ";                          break;
      case 4003: _Txt_Error = "    ";                            break;
      case 4004: _Txt_Error = "    ";            break;
      case 4005: _Txt_Error = "      ";             break;
      case 4006: _Txt_Error = "    ";                     break;
      case 4007: _Txt_Error = "    ";                         break;
      case 4008: _Txt_Error = " ";                             break;
      case 4009: _Txt_Error = "   ";                   break;
      case 4010: _Txt_Error = "    ";                       break;
      case 4011: _Txt_Error = "  ";                                  break;
      case 4012: _Txt_Error = "    ";                              break;
      case 4013: _Txt_Error = "  ";                                         break;
      case 4014: _Txt_Error = " ";                                     break;
      case 4015: _Txt_Error = " ";                                    break;
      case 4016: _Txt_Error = " ";                             break;
      case 4017: _Txt_Error = " DLL  ";                                 break;
      case 4018: _Txt_Error = "  ";                         break;
      case 4019: _Txt_Error = "  ";                              break;
      case 4020: _Txt_Error = "     ";        break; 
      case 4021: _Txt_Error = "   ,   "; break;
      case 4022: _Txt_Error = " ";                                          break;
      case 4050: _Txt_Error = "   ";              break;
      case 4051: _Txt_Error = "   ";                 break;
      case 4052: _Txt_Error = "   ";                     break;
      case 4053: _Txt_Error = " ";                                          break;
      case 4054: _Txt_Error = "  -";            break;
      case 4055: _Txt_Error = "  ";                     break;
      case 4056: _Txt_Error = " ";                                    break;
      case 4057: _Txt_Error = "   ";                 break;
      case 4058: _Txt_Error = "   ";                     break;
      case 4059: _Txt_Error = "     ";                  break;
      case 4060: _Txt_Error = "  ";                                    break;
      case 4061: _Txt_Error = "  ";                                   break;
      case 4062: _Txt_Error = "   string";                          break;
      case 4063: _Txt_Error = "   integer";                         break;
      case 4064: _Txt_Error = "   double";                          break;
      case 4065: _Txt_Error = "    ";                   break;
      case 4066: _Txt_Error = "     ";  break;
      case 4067: _Txt_Error = "    ";                 break;
      case 4099: _Txt_Error = " ";                                             break;
      case 4100: _Txt_Error = "    ";                              break;
      case 4101: _Txt_Error = "  ";                                  break;
      case 4102: _Txt_Error = "   ";                           break;
      case 4103: _Txt_Error = "  ";                                 break;
      case 4104: _Txt_Error = "    ";                     break;
      case 4105: _Txt_Error = "    ";                                 break;
      case 4106: _Txt_Error = " ";                                      break;
      case 4107: _Txt_Error = "     ";         break;
      case 4108: _Txt_Error = "  ";                                   break;
      case 4109: _Txt_Error = "  .   .";     break;
      case 4110: _Txt_Error = "   .    .";  break;
      case 4111: _Txt_Error = "   .    ."; break;
      case 4200: _Txt_Error = "  ";                                   break;
      case 4201: _Txt_Error = "   ";                  break;
      case 4202: _Txt_Error = "  ";                                    break;
      case 4203: _Txt_Error = "  ";                                 break;
      case 4204: _Txt_Error = "  ";                                       break;
      case 4205: _Txt_Error = "  ";                                break;
      case 4206: _Txt_Error = "   ";                            break;
      case 4207: _Txt_Error = "    ";                            break;
      default:   _Txt_Error = " ";
   }
   if(_Num_Error!=0)
   {  Print(ex_Name_for_System +_Function+"("+_Num_Error+")"+_Txt_Error);
      output_alert_ERR(ex_Name_for_System +_Function+"("+_Num_Error+")"+_Txt_Error);
   }
//----
  return(_Txt_Error);
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------------------------------------+
//|                                   
//+------------------------------------------------------------------------------------------------+
//| value_stoch()     (_Us_TF_Stoch) 
//| direct_stoch()    
//| stoch_chenge_dir()     
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                12.07.2011
//+------------------------------------------------------------------+
//| value_stoch()     (_Us_TF_Stoch) 
//|     (_TF_Win)  
//| :
//| -   , ( Period()  , 
//|        
//| -   
//| -  MODE_MAIN  MODE_SIGNAL
//| -   
//+------------------------------------------------------------------+
double value_stoch(int _TF_Win, int _Us_TF_Stoch, int _Mode_Line, int _i)
{  double _Value;
//---------
   if(_Mode_Line == MODE_MAIN)
      _Value = iCustom(Symbol(),_TF_Win,"iSWOL_for_ex",_Us_TF_Stoch,0,_i);
   if(_Mode_Line == MODE_SIGNAL)
      _Value = iCustom(Symbol(),_TF_Win,"iSWOL_for_ex",_Us_TF_Stoch,1,_i);
//---------
   return(_Value);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                12.07.2011
//+------------------------------------------------------------------+
//| direct_stoch()    
//| :
//| -   , (  Period()  , 
//|        )
//| -   
//+------------------------------------------------------------------+
string direct_stoch(int _TF_Win, int _Us_TF_Stoch)
{  string _Direct = "NO";
//---------
   double _Stoch_0 = value_stoch(_TF_Win,_Us_TF_Stoch,MODE_MAIN,0);
   double _Stoch_1 = value_stoch(_TF_Win,_Us_TF_Stoch,MODE_MAIN,1);
   if(_Stoch_0 > _Stoch_1)
      _Direct = "UP";
   if(_Stoch_0 < _Stoch_1)
      _Direct = "DN";
//---------
   return(_Direct);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                12.07.2011
//+------------------------------------------------------------------+
//| stoch_chenge_dir()     
//|     ,    
//| :
//| -   , (  Period()  , 
//|        )
//| -   
//+------------------------------------------------------------------+
bool stoch_chenge_dir(int _TF_Win, int _Us_TF_Stoch)
{  string _Function = "stoch_chenge_dir():";
   bool _CDir = false;
   static datetime 
      _Last_Time_Fix_M1  = 0,
      _Last_Time_Fix_M5  = 0,
      _Last_Time_Fix_M15 = 0,
      _Last_Time_Fix_M30 = 0,
      _Last_Time_Fix_H1  = 0,
      _Last_Time_Fix_H4  = 0,
      _Last_Time_Fix_D1  = 0,
      _Last_Time_Fix_W1  = 0,
      _Last_Time_Fix_MN1 = 0;
   switch(_Us_TF_Stoch)   {
      case PERIOD_M1:
         if(_Last_Time_Fix_M1 == 0)_Last_Time_Fix_M1 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_M1 < _Us_TF_Stoch*60) return(_CDir);
      break;
      case PERIOD_M5:
         if(_Last_Time_Fix_M5 == 0)_Last_Time_Fix_M5 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_M5 < _Us_TF_Stoch*60) return(_CDir);
      break;
      case PERIOD_M15:
         if(_Last_Time_Fix_M15 == 0)_Last_Time_Fix_M15 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_M15 < _Us_TF_Stoch*60) return(_CDir);
      break;
      case PERIOD_M30:
         if(_Last_Time_Fix_M30 == 0)_Last_Time_Fix_M30 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_M30 < _Us_TF_Stoch*60) return(_CDir);
      break;
      case PERIOD_H1:
         if(_Last_Time_Fix_H1 == 0)_Last_Time_Fix_H1 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_H1 < _Us_TF_Stoch*60) return(_CDir);
      break;
      case PERIOD_H4:
         if(_Last_Time_Fix_H4 == 0)_Last_Time_Fix_H4 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_H4 < _Us_TF_Stoch*60) return(_CDir);
      break;
      case PERIOD_D1:
         if(_Last_Time_Fix_D1 == 0)_Last_Time_Fix_D1 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_D1 < _Us_TF_Stoch*60) return(_CDir);
      break;
      case PERIOD_W1:
         if(_Last_Time_Fix_W1 == 0)_Last_Time_Fix_W1 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_W1 < _Us_TF_Stoch*60) return(_CDir);
      break;
      case PERIOD_MN1:
         if(_Last_Time_Fix_MN1 == 0)_Last_Time_Fix_MN1 = TimeCurrent();
         if(TimeCurrent() - _Last_Time_Fix_MN1 < _Us_TF_Stoch*60) return(_CDir);
      break;
      default: 
         output_alert_ERR(_Function+" TF");
      break;
   }
//---------
   double _Stoch_0M = value_stoch(_TF_Win,_Us_TF_Stoch,MODE_MAIN,  0);
   double _Stoch_0S = value_stoch(_TF_Win,_Us_TF_Stoch,MODE_SIGNAL,0);
   double _Stoch_1M = value_stoch(_TF_Win,_Us_TF_Stoch,MODE_MAIN,  1);
   double _Stoch_1S = value_stoch(_TF_Win,_Us_TF_Stoch,MODE_SIGNAL,1);
   if(_Stoch_0M >= Stoch_Level && _Stoch_0M <= 100-Stoch_Level)  {
      if(_Stoch_0M > _Stoch_0S && _Stoch_1M <= _Stoch_1S)   _CDir = true;
      if(_Stoch_0M < _Stoch_0S && _Stoch_1M >= _Stoch_1S)   _CDir = true;
      if(_Stoch_1M < Stoch_Level || _Stoch_1M > 100-Stoch_Level) _CDir = true;
      if(_CDir == true) {
         output_alert(_Function+"   ");
         switch(_Us_TF_Stoch)   {
            case PERIOD_M1: _Last_Time_Fix_M1  = TimeCurrent(); break;
            case PERIOD_M5: _Last_Time_Fix_M5  = TimeCurrent(); break;
            case PERIOD_M15:_Last_Time_Fix_M15 = TimeCurrent(); break;
            case PERIOD_M30:_Last_Time_Fix_M30 = TimeCurrent(); break;
            case PERIOD_H1: _Last_Time_Fix_H1  = TimeCurrent(); break;
            case PERIOD_H4: _Last_Time_Fix_H4  = TimeCurrent(); break;
            case PERIOD_D1: _Last_Time_Fix_D1  = TimeCurrent(); break;
            case PERIOD_W1: _Last_Time_Fix_W1  = TimeCurrent(); break;
            case PERIOD_MN1:_Last_Time_Fix_MN1 = TimeCurrent(); break;
            default:break;
         }
      }
   }  
//---------
   return(_CDir);
}
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//|   valenok2003@mail.ru                                18.07.2011
//+------------------------------------------------------------------+
//|   signals_generator()
//+------------------------------------------------------------------+
void signals_generator()
{  string _Function = "signals_generator():";
   string
      _Signal_Open  = NO_SIGNAL,
      _Signal_Close = NO_SIGNAL;
//-------------------------------------------------------------------
   if(Comment_ON) {
      Txt_Comment = Txt_Comment + "\n"+"==  ==";
      Txt_Comment = Txt_Comment + "\n"+" :";
   }
//-------------------------------------------------------------------
//---------    ----------------------------
//--------------------------------------------------------------------
//             BigTrend
//--------------------------------------------------------------------
   Txt_Comment = Txt_Comment + "\n"+"logic_BT1_BT5.mqh:";
//---------   -------------------------------------
   string BigTrend_M1 = "NO";
   string BigTrend_M5 = "NO";
   double BigTrend_UP_M1_0 = iCustom(Symbol(),1,"iBigTrend_for_ex",0,0);
   double BigTrend_DN_M1_0 = iCustom(Symbol(),1,"iBigTrend_for_ex",1,0);
   double BigTrend_UP_M1_1 = iCustom(Symbol(),1,"iBigTrend_for_ex",0,1);
   double BigTrend_DN_M1_1 = iCustom(Symbol(),1,"iBigTrend_for_ex",1,1);
   double BigTrend_UP_M1_2 = iCustom(Symbol(),1,"iBigTrend_for_ex",0,2);
   double BigTrend_DN_M1_2 = iCustom(Symbol(),1,"iBigTrend_for_ex",1,2);
   double BigTrend_UP_M1_3 = iCustom(Symbol(),1,"iBigTrend_for_ex",0,3);
   double BigTrend_DN_M1_3 = iCustom(Symbol(),1,"iBigTrend_for_ex",1,3);
   double BigTrend_UP_M5_0 = iCustom(Symbol(),5,"iBigTrend_for_ex",0,0);
   double BigTrend_DN_M5_0 = iCustom(Symbol(),5,"iBigTrend_for_ex",1,0);
   double BigTrend_UP_M5_1 = iCustom(Symbol(),5,"iBigTrend_for_ex",0,1);
   double BigTrend_DN_M5_1 = iCustom(Symbol(),5,"iBigTrend_for_ex",1,1);
   double BigTrend_UP_M5_2 = iCustom(Symbol(),5,"iBigTrend_for_ex",0,2);
   double BigTrend_DN_M5_2 = iCustom(Symbol(),5,"iBigTrend_for_ex",1,2);
//---------    ------------------------------
   static bool 
      _FLAG_BT_UP = true,
      _FLAG_BT_DN = true;
//---------
   if(BigTrend_UP_M1_0 != EMPTY_VALUE
   && BigTrend_UP_M1_1 != EMPTY_VALUE
   && BigTrend_DN_M1_2 != EMPTY_VALUE
   && BigTrend_DN_M1_3 != EMPTY_VALUE
   ) BigTrend_M1 = "UP";
//---------
   if(BigTrend_DN_M1_0 != EMPTY_VALUE
   && BigTrend_DN_M1_1 != EMPTY_VALUE
   && BigTrend_UP_M1_2 != EMPTY_VALUE
   && BigTrend_UP_M1_3 != EMPTY_VALUE
   ) BigTrend_M1 = "DN";
//---------
//---------
   if(BigTrend_UP_M5_0 != EMPTY_VALUE
   && BigTrend_UP_M5_1 != EMPTY_VALUE
   ) BigTrend_M5 = "UP";
//---------
   if(BigTrend_DN_M5_0 != EMPTY_VALUE
   && BigTrend_DN_M5_1 != EMPTY_VALUE
   ) BigTrend_M5 = "DN";
//---------
//---------
   if(_FLAG_BT_UP
   && BigTrend_M1 == "UP"
   && BigTrend_M5 == "UP")   {
      _Signal_Open  = SIGNAL_OP_BUY;
      _FLAG_BT_UP = false;
      _FLAG_BT_DN = true;
      output_alert("logic_BT1_BT5  - UP");
      Comment_Order = ex_Name_for_Comment_Order+" BT "+" Magic="+Magic;
   }
   if(_FLAG_BT_DN
   && BigTrend_M1 == "DN"
   && BigTrend_M5 == "DN")   {
      _Signal_Open  = SIGNAL_OP_SELL;
      _FLAG_BT_UP = true;
      _FLAG_BT_DN = false;
      output_alert("logic_BT1_BT5  - DN");
      Comment_Order = ex_Name_for_Comment_Order+" BT "+" Magic="+Magic;
   }
//-------------------------------------------------------------------   
   Txt_Comment = Txt_Comment + "\n"+"- BigTrend_M1 = " + BigTrend_M1;
   Txt_Comment = Txt_Comment + "\n"+"- BigTrend_M5 = " + BigTrend_M5;
//                       
//---------------------------------------------------------------------
//--------------------------------------------------------------------
//             6- 
//--------------------------------------------------------------------
   Txt_Comment = Txt_Comment + "\n"+"logic_stoch.mqh:";
//---------   -------------------------------------
   double Level_Stoch = value_stoch(1, 1, MODE_MAIN,0);
   string Dir_Stoch1  = direct_stoch(1, 1);
   string Dir_Stoch5  = direct_stoch(1, 5);
   string Dir_Stoch15 = direct_stoch(5, 15);
   string Dir_Stoch30 = direct_stoch(15, 30);
   string Dir_Stoch60 = direct_stoch(30, 60);
   string Dir_Stoch240 = direct_stoch(60, 240);
//---------    ------------------------------
   static bool 
      _FLAG_ST_UP = true,
      _FLAG_ST_DN = true;
//---------
   if((Dir_Stoch1 == "UP" || Level_Stoch > 100-Stoch_Level)
   && _FLAG_ST_UP
   && Dir_Stoch5  == "UP" && Dir_Stoch15 == "UP" 
   && Dir_Stoch30 == "UP" && Dir_Stoch60 == "UP" 
//   && Dir_Stoch240 == "UP" 
   )  {
      _Signal_Open  = SIGNAL_OP_BUY;
      _FLAG_ST_UP = false;
      _FLAG_ST_DN = true;
      output_alert("logic_stoch  - UP");
      Comment_Order = ex_Name_for_Comment_Order+" St "+" Magic="+Magic;
   }

   if((Dir_Stoch1 == "DN" || Level_Stoch < Stoch_Level)
   && _FLAG_ST_DN
   && Dir_Stoch5  == "DN" && Dir_Stoch15 == "DN" 
   && Dir_Stoch30 == "DN" && Dir_Stoch60 == "DN" 
//   && Dir_Stoch240 == "DN" 
   )  {
      _Signal_Open  = SIGNAL_OP_SELL;
      _FLAG_ST_UP = true;
      _FLAG_ST_DN = false;
      output_alert("logic_stoch  - DN");
      Comment_Order = ex_Name_for_Comment_Order+" St "+" Magic="+Magic;
   }
   if(stoch_chenge_dir(5,5)) {
      Max_Num_Orders ++;
      _FLAG_ST_UP = true;
      _FLAG_ST_DN = true;
   }
//-----------
   Txt_Comment = Txt_Comment + "\n"+"- FLAG_ST_UP = "+_FLAG_ST_UP;
   Txt_Comment = Txt_Comment + "\n"+"- FLAG_ST_DN = "+_FLAG_ST_DN;
//---------------------------------------------------------------------
//                       
//---------------------------------------------------------------------
//---------     ------------------------
//---------------------------------------------------------------------
//---------
//---------
//---------------------------------------------------------------------
//---------    -------------------------------
//--------------------------------------------------------------------
//              
//--------------------------------------------------------------------
   Txt_Comment = Txt_Comment + "\n"+"logic_regres_canal.mqh:";
   int Max_Bars_for_Tral_STOPORDER_lrc  = 1200;
   int Min_Bars_for_Tral_STOPORDER_lrc = 10;
   int Dist_For_Top_lrc  = 280;
   int Dist_For_Boot_lrc = 250;   
//---------   -------------------------------------
//  
   int Degree = 1;
   double Kstd = 1.8;
   int Bars_Canal = 56;
   int Shift = 0;
//---------
//---------
   int Nul_Line_Reg  = 0;
   int Top_Line_Reg  = 1;
   int Boot_Line_Reg = 2;
//---------
   double valueH4_iReg_Top_0  = iCustom(NULL,PERIOD_H4,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Top_Line_Reg, 0);
   double valueH4_iReg_Med_0  = iCustom(NULL,PERIOD_H4,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Nul_Line_Reg, 0);
   double valueH4_iReg_Med_1  = iCustom(NULL,PERIOD_H4,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Nul_Line_Reg, 1);
   double valueH4_iReg_Boot_0 = iCustom(NULL,PERIOD_H4,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Boot_Line_Reg,0);
//---------
   double valueH1_iReg_Top_0  = iCustom(NULL,PERIOD_H1,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Top_Line_Reg, 0);
   double valueH1_iReg_Med_0  = iCustom(NULL,PERIOD_H1,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Nul_Line_Reg, 0);
   double valueH1_iReg_Med_1  = iCustom(NULL,PERIOD_H1,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Nul_Line_Reg, 1);
   double valueH1_iReg_Boot_0 = iCustom(NULL,PERIOD_H1,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Boot_Line_Reg,0);
//---------
   double valueM15_iReg_Top_0  = iCustom(NULL,PERIOD_M15,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Top_Line_Reg, 0);
   double valueM15_iReg_Med_0  = iCustom(NULL,PERIOD_M15,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Nul_Line_Reg, 0);
   double valueM15_iReg_Med_1  = iCustom(NULL,PERIOD_M15,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Nul_Line_Reg, 1);
   double valueM15_iReg_Boot_0 = iCustom(NULL,PERIOD_M15,"i-Regr",Degree,Kstd,Bars_Canal,Shift,Boot_Line_Reg,0);
//---------    ------------------------------
   double Wight_CanalH4 = valueH4_iReg_Top_0 - valueH4_iReg_Boot_0;
   double Level_Top_TurnH4  = valueH4_iReg_Top_0 - Wight_CanalH4/4;
   double Level_Boot_TurnH4 = valueH4_iReg_Boot_0 + Wight_CanalH4/4;
//---------
   double Wight_CanalH1 = valueH1_iReg_Top_0 - valueH1_iReg_Boot_0;
   double Level_Top_TurnH1  = valueH1_iReg_Top_0 - Wight_CanalH1/4;
   double Level_Boot_TurnH1 = valueH1_iReg_Boot_0 + Wight_CanalH1/4;
//---------
   double Wight_CanalM15 = valueM15_iReg_Top_0 - valueM15_iReg_Boot_0;
   double Level_Top_TurnM15  = valueM15_iReg_Top_0 - Wight_CanalM15/4;
   double Level_Boot_TurnM15 = valueM15_iReg_Boot_0 + Wight_CanalM15/4;
//---------    
   if(Ask >= valueH4_iReg_Top_0  || Bid <= valueH4_iReg_Boot_0
   || Ask >= valueH1_iReg_Top_0  || Bid <= valueH1_iReg_Boot_0
   || Ask >= valueM15_iReg_Top_0 || Bid <= valueM15_iReg_Boot_0
   ) {
      ALLOW_SET_ORDER = false;
      Tral_SL = 0;
      if(Ask >= valueH4_iReg_Top_0  || Bid <= valueH4_iReg_Boot_0)   {
         Txt_Comment = Txt_Comment + "\n"+"-    , H4";
         Txt_Comment = Txt_Comment + "\n"+"-  StopLoss  H4";
      }
      if(Ask >= valueH1_iReg_Top_0  || Bid <= valueH1_iReg_Boot_0)   {
         Txt_Comment = Txt_Comment + "\n"+"-    , H1";
         Txt_Comment = Txt_Comment + "\n"+"-  StopLoss  H1";
      }
      if(Ask >= valueM15_iReg_Top_0  || Bid <= valueM15_iReg_Boot_0)   {
         Txt_Comment = Txt_Comment + "\n"+"-    , M15";
         Txt_Comment = Txt_Comment + "\n"+"-  StopLoss  M15";
      }
      if(Ask >= valueH4_iReg_Top_0
      || Ask >= valueH1_iReg_Top_0
      || Ask >= valueM15_iReg_Top_0
      )   {
         Num_Bars_for_Lock_BUYSTOP  = Max_Bars_for_Tral_STOPORDER_lrc;
         Num_Bars_for_Lock_SELLSTOP = Us_Num_Bars_for_Lock;
      }
      if(Bid <= valueH4_iReg_Boot_0
      || Bid <= valueH1_iReg_Boot_0
      || Bid <= valueM15_iReg_Boot_0      
      )  {
         Num_Bars_for_Lock_SELLSTOP = Max_Bars_for_Tral_STOPORDER_lrc;
         Num_Bars_for_Lock_BUYSTOP  = Us_Num_Bars_for_Lock;
      }
   }
//---------    
   else  {
      ALLOW_SET_ORDER = true;
      Tral_SL = Us_Tral_SL;
//---------     
      if(Ask < Level_Top_TurnH4 && Bid > Level_Boot_TurnH4
      && Ask < Level_Top_TurnH1 && Bid > Level_Boot_TurnH1
      && Ask < Level_Top_TurnM15 && Bid > Level_Boot_TurnM15
      )  { 
         Num_Bars_for_Lock_BUYSTOP  = Us_Num_Bars_for_Lock;
         Num_Bars_for_Lock_SELLSTOP = Us_Num_Bars_for_Lock;
         Dist_For_Top = Us_Dist_For_Top;
         Dist_For_Boot = Us_Dist_For_Boot;
         ALLOW_TRAL_BUYSTOP  = true;
         ALLOW_TRAL_SELLSTOP = true;
      }
//---------    
//---------   
      if(Ask >= Level_Top_TurnH4
      || Ask >= Level_Top_TurnH1
      || Ask >= Level_Top_TurnM15
      )  {              
         ALLOW_TRAL_BUYSTOP   = false;
         Num_Bars_for_Lock_SELLSTOP = Min_Bars_for_Tral_STOPORDER_lrc;
         Num_Bars_for_Lock_BUYSTOP  = Max_Bars_for_Tral_STOPORDER_lrc;
         Dist_For_Top = Dist_For_Top_lrc;
         if(Ask >= Level_Top_TurnH4)   {
            Txt_Comment = Txt_Comment + "\n"+"- Level_Top_TurnH4 = "+DoubleToStr(Level_Top_TurnH4,Digits);
            Txt_Comment = Txt_Comment + "\n"+"-    H4 BUY -> SELL";
            Txt_Comment = Txt_Comment + "\n"+"-  SELLSTOP  H4";         
         }
         if(Ask >= Level_Top_TurnH1)   {
            Txt_Comment = Txt_Comment + "\n"+"- Level_Top_TurnH1 = "+DoubleToStr(Level_Top_TurnH1,Digits);
            Txt_Comment = Txt_Comment + "\n"+"-    H1 BUY -> SELL";
            Txt_Comment = Txt_Comment + "\n"+"-  SELLSTOP  H1";         
         }
         if(Ask >= Level_Top_TurnM15)   {
            Txt_Comment = Txt_Comment + "\n"+"- Level_Top_TurnM15 = "+DoubleToStr(Level_Top_TurnM15,Digits);
            Txt_Comment = Txt_Comment + "\n"+"-    M15 BUY -> SELL";
            Txt_Comment = Txt_Comment + "\n"+"-  SELLSTOP  M15";         
         }
         if(_Signal_Open == SIGNAL_OP_BUY)   {
            _Signal_Open = SIGNAL_OP_SELL;
         }
      }
//---------   
      if(Bid <= Level_Boot_TurnH4
      || Bid <= Level_Boot_TurnH1
      || Bid <= Level_Boot_TurnM15
      )  {
         ALLOW_TRAL_SELLSTOP  = false;
         Num_Bars_for_Lock_SELLSTOP = Max_Bars_for_Tral_STOPORDER_lrc;
         Num_Bars_for_Lock_BUYSTOP  = Min_Bars_for_Tral_STOPORDER_lrc;
         Dist_For_Boot = Dist_For_Boot_lrc;
         if(Bid <= Level_Boot_TurnH4)   {
            Txt_Comment = Txt_Comment + "\n"+"- Level_Boot_TurnH4 = "+DoubleToStr(Level_Boot_TurnH4,Digits);
            Txt_Comment = Txt_Comment + "\n"+"-    H4 SELL -> BUY";
            Txt_Comment = Txt_Comment + "\n"+"-  SELLSTOP  H4";         
         }
         if(Bid <= Level_Boot_TurnH1)   {
            Txt_Comment = Txt_Comment + "\n"+"- Level_Boot_TurnH1 = "+DoubleToStr(Level_Boot_TurnH1,Digits);
            Txt_Comment = Txt_Comment + "\n"+"-    H1 SELL -> BUY";
            Txt_Comment = Txt_Comment + "\n"+"-  SELLSTOP  H1";         
         }
         if(Bid <= Level_Boot_TurnM15)   {
            Txt_Comment = Txt_Comment + "\n"+"- Level_Boot_TurnM15 = "+DoubleToStr(Level_Boot_TurnM15,Digits);
            Txt_Comment = Txt_Comment + "\n"+"-    M15 SELL -> BUY";
            Txt_Comment = Txt_Comment + "\n"+"-  SELLSTOP  M15";         
         }
         if(_Signal_Open == SIGNAL_OP_SELL)  {
            _Signal_Open = SIGNAL_OP_BUY;
         }
      }
   }
//---------------------------------------------------------------------
//                       
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//---------     ---------------------------
//--------------------------------------------------------------------
//-------------------------------------------------------------------
//           
//        
   if(PROTECT_ENTRY) {
      static bool FLAG_PROTECT_OPEN_IN_FIRST_TICK = true;
      if(FLAG_PROTECT_OPEN_IN_FIRST_TICK == true)
      {  if(_Signal_Open == NO_SIGNAL) FLAG_PROTECT_OPEN_IN_FIRST_TICK = false; 
         else 
         {  _Signal_Open = NO_SIGNAL;
            output_alert("     \n   ");
         }
      }
   }
//---------------------------------------------------------------------
//            
//         
   string  
      _Signal_Open_TMP = NO_SIGNAL, 
      _Signal_Close_TMP= NO_SIGNAL;
   static string _Previos_Signal_Open  = NO_SIGNAL;
   static string _Previos_Signal_Close = NO_SIGNAL;
//-------
   if(_Signal_Open  == _Previos_Signal_Open) _Signal_Open_TMP = NO_SIGNAL;
   else 
   {  _Previos_Signal_Open = _Signal_Open;
      _Signal_Open_TMP = _Signal_Open;
   }
//-------
   if(_Signal_Close == _Previos_Signal_Close || _Signal_Close == NO_SIGNAL)_Signal_Close_TMP = NO_SIGNAL;
   else 
   {  _Previos_Signal_Close = _Signal_Close;
      _Signal_Close_TMP = _Signal_Close;
   }
//-------------   -------------------------------
static string 
   _Old_Sig_Open = "",
   _Old_Sig_Close = "";
   if(_Signal_Open  == _Old_Sig_Open)
   {  output_alert_ERR(_Function+":   "  + _Signal_Open);
      _Old_Sig_Open = _Signal_Open;
   }
   if(_Signal_Close  == _Old_Sig_Close)         
   {  output_alert_ERR(_Function+":   "  + _Signal_Close);
      _Old_Sig_Open = _Signal_Open;
   }
//---------------------------------------------------------------------
   Signal_Open  = NO_SIGNAL;
   Signal_Close = NO_SIGNAL;
   Signal_Open  = _Signal_Open_TMP;
   Signal_Close = _Signal_Close_TMP;
   if(Signal_Open !=NO_SIGNAL)  
      output_alert_ERR(_Function+"Signal_Open = "  + Signal_Open);
   if(Signal_Close!=NO_SIGNAL)  
      output_alert_ERR(_Function+"Signal_Close = " + Signal_Close);
//-------------
   return;
} 
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//|                                                         init.mq4 |
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{  ex_Name_for_System = txt_TF(Period())+ "|"+ Symbol()+ "|"+ ex_Name + ":";
   ex_Name_for_Comment_Order = txt_TF(Period())+ "|"+ "Ex" + ":";
   Dist_For_Top = Us_Dist_For_Top;
   Dist_For_Boot = Us_Dist_For_Boot;
   Tral_SL = Us_Tral_SL;
   Num_Bars_for_Lock_BUYSTOP  = Us_Num_Bars_for_Lock;
   Num_Bars_for_Lock_SELLSTOP = Us_Num_Bars_for_Lock;
   Level_OutLoss = Us_Level_OutLoss;
   Stoch_Level = Us_Stoch_Level;
   Max_Num_Orders = Us_Max_Num_Orders;
   SOUND_SIGNAL      = false;
   ALLOW_SET_SL_TP   = false;
   ALLOW_SET_ORDER   = true;
   ALLOW_OPEN_BUY    = false;
   ALLOW_OPEN_SELL   = false;
   ALLOW_CLOSE_BUY   = false;
   ALLOW_CLOSE_SELL  = false;
   ALLOW_CLOSE_ALL   = false;
   CLOSE_ALL_FIX_PROFIT = false;
   ALLOW_SET_BUYSTOP    = true;
   ALLOW_SET_SELLSTOP   = true;
   DEL_ALL_BUYSTOP   = false;
   DEL_ALL_SELLSTOP  = false;
   Start_Equity = AccountEquity();
//----
   if(Magic == 0) Magic = Period()+ Magic;
   if(Symbol() == "USDCHF") Magic = 2;
   //       
//----
   Comment_Order = "";
//----
   if(!Draw_ARROW)
   {  ColorArrowBuy = CLR_NONE;
      ColorArrowSell = CLR_NONE;
   }
   string _Name_Obj = NAME_EXPERT + "Type_Account";
   if(!IsDemo())  {
      ObjectCreate (_Name_Obj, OBJ_LABEL, 0, 0, 0);
      ObjectSet    (_Name_Obj, OBJPROP_CORNER, 1);
      ObjectSet    (_Name_Obj, OBJPROP_XDISTANCE, 15);
      ObjectSet    (_Name_Obj, OBJPROP_YDISTANCE, 35);
      ObjectSetText(_Name_Obj, " ר!", 10, "Lucida Console", Yellow);
   }
   else  {
      ObjectCreate (_Name_Obj, OBJ_LABEL, 0, 0, 0);
      ObjectSet    (_Name_Obj, OBJPROP_CORNER, 1);
      ObjectSet    (_Name_Obj, OBJPROP_XDISTANCE, 15);
      ObjectSet    (_Name_Obj, OBJPROP_YDISTANCE, 35);
      ObjectSetText(_Name_Obj, " !", 10, "Lucida Console", DodgerBlue);
   }

//----
   return(0);
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//|                                                       deinit.mq4 |
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   ObjectsDeleteAll();//(NAME_EXPERT + "Type_Account");   
//----
   return(0);
}
//+------------------------------------------------------------------+
//+-------
//+------------------------------------------------------------------+
//|                   - start() 
//+------------------------------------------------------------------+
//+-------
//+-------
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{  string Function = "start():";
   Txt_Comment = "";
//----
   check_dist();
//-------   ------
   if(ALLOW_SET_SL_TP)
   {  Ticket = set_SL_and_TP(Ticket, Loss, Profit);
      if(Ticket == 0) 
      {  ALLOW_SET_SL_TP = false;
         ALLOW_SET_ORDER = true;
      }
   }
//------------------------------
   SOUND_SIGNAL = output_signal(SOUND_SIGNAL);   
   Slip = slipp();
   signals_generator();
// -----  --------------   
   if(OrdersTotal() > 0)
   {  if(Signal_Close == SIGNAL_CL_BUY || ALLOW_CLOSE_BUY)
      {  ALLOW_CLOSE_BUY = true;
         if(close_all_buy(Magic)==true)   
         {  ALLOW_CLOSE_BUY = false;
         }
      }
      if(Signal_Close == SIGNAL_CL_SELL || ALLOW_CLOSE_SELL)
      {  ALLOW_CLOSE_SELL = true;
         if(close_all_sell(Magic)==true)  
         {  ALLOW_CLOSE_SELL = false;
         }
      }
      if(Signal_Close == SIGNAL_CL_ALL || ALLOW_CLOSE_ALL || CLOSE_ALL_FIX_PROFIT)
      {  ALLOW_CLOSE_ALL = true;
         if(close_all_this_symbol(Magic)==true)  
         {  ALLOW_CLOSE_ALL = false;
            CLOSE_ALL_FIX_PROFIT = false;
         }
      }
//      if(!ALLOW_SET_BUYSTOP  || DEL_ALL_BUYSTOP) {
//         DEL_ALL_BUYSTOP  = true;
//         //  buystop,   DEL_ALL_BUYSTOP = false
//      }
//      if(!ALLOW_SET_SELLSTOP || DEL_ALL_SELLSTOP){
//         DEL_ALL_SELLSTOP = true;
//         //  sellstop,   DEL_ALL_SELLSTOP = false
//      }
   }
// -----  -------------
   tral_SL(Magic);
   set_outloss();
   set_lock();
   tral_lock();
//+-----------   ------------------------------------+
   if(Signal_Open!= "NO") output_alert_ERR(Function+"Signal_Open = "+Signal_Open);
//+------------------------------------------------------------------+
   Lot = money_menegment(Risk,Us_Lot);
   CLOSE_ALL_FIX_PROFIT = fix_profit(Fix_Profit);
   if(ALLOW_SET_ORDER)
   {  if(Signal_Open == SIGNAL_OP_BUY || ALLOW_OPEN_BUY)
      {  if(!cnt_num_orders(OP_BUY, Magic)) return(0);
         ALLOW_OPEN_BUY = true;
         Ticket = open_order_buy(Comment_Order);
         if(Ticket > 0)
         {  ALLOW_SET_SL_TP = true;
            ALLOW_OPEN_BUY  = false;
            ALLOW_SET_ORDER = false;
         }
         return(0);
      }
      if(Signal_Open == SIGNAL_OP_SELL || ALLOW_OPEN_SELL)
      {  if(!cnt_num_orders(OP_SELL, Magic)) return(0);
         ALLOW_OPEN_SELL = true;
         Ticket = open_order_sell(Comment_Order);
         if(Ticket > 0)
         {  ALLOW_SET_SL_TP = true;
            ALLOW_OPEN_SELL = false;
            ALLOW_SET_ORDER = false;
         }
         return(0);
      }
   }
   comment_num_orders(Magic);
   output_comment(Txt_Comment);
   output_advert();
//----
   return(0);
}
//+------------------------------------------------------------------+
//+-------

//+------------------------------------------------------------------+

